// pwdchg2000.c : Defines the entry point for the DLL application.
//

#include "pwdchg2000.h"

static char userName[256], newPwd[256], cmd[4096];
static BOOL changepwd = FALSE;
static HANDLE hlog;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	hlog = RegisterEventSource(NULL, "pwdchg2000.dll");
/*
	char *msg[] = { "DllMain called" };
	HANDLE hlog = RegisterEventSource(NULL, "Application");
	ReportEvent(hlog, EVENTLOG_INFORMATION_TYPE, 0, 0, NULL, 1, 0, msg, NULL);
*/	
    return TRUE;
}

BOOLEAN WINAPI PasswordFilter(
  PUNICODE_STRING AccountName,
  PUNICODE_STRING FullName,
  PUNICODE_STRING Password,
  BOOLEAN SetOperation
  ) {
	changepwd = !SetOperation;

	return TRUE;
}

NTSTATUS WINAPI PasswordChangeNotify(
  PUNICODE_STRING UserName,
  ULONG RelativeId,
  PUNICODE_STRING NewPassword
  ) {
	BOOL bad = FALSE;

	PROCESS_INFORMATION pinfo;

	STARTUPINFO sinfo = {
		sizeof(STARTUPINFO),
		NULL, 
		NULL, 
		NULL,
		0,
		0,
		0,
		0,
		0,
		0,
		0,
		0,//STARTF_USESHOWWINDOW,
		0,//SW_HIDE,
		0,
		NULL,
		NULL,
		NULL,
		NULL };

	// Get the username and the password
	ZeroMemory(userName, sizeof(userName));
	ZeroMemory(newPwd, sizeof(newPwd));

	// ->Length contains the number of bytes rather than Wide Chars in the buffer!
	WideCharToMultiByte(CP_ACP, 0, UserName->Buffer, UserName->Length / 2, userName, sizeof(userName), NULL, &bad);
	WideCharToMultiByte(CP_ACP, 0, NewPassword->Buffer, NewPassword->Length / 2, newPwd, sizeof(newPwd), NULL, &bad);

	ZeroMemory(cmd, sizeof(cmd));

	{
		char sysroot[MAX_PATH];
		GetEnvironmentVariable("systemroot", sysroot, sizeof(sysroot));
		sprintf(cmd, "%s\\%s %s\\%s %s %s %s %s", sysroot, "system32\\wscript.exe", sysroot, "system32\\pwdchg2000.js", "//B //Nologo", userName, newPwd, (changepwd)?"change":"set");
	}

	/*{char *msg[] = { cmd };
	HANDLE hlog = RegisterEventSource(NULL, "pwdchg2000.dll");
	ReportEvent(hlog, EVENTLOG_INFORMATION_TYPE, 0, 0, NULL, 1, 0, msg, NULL);}*/

	if (!CreateProcess(NULL, cmd, NULL, NULL, FALSE, NORMAL_PRIORITY_CLASS, NULL, NULL, &sinfo, &pinfo)) {
		char *msg[] = { "pwdchg2000.dll: Create Process Failed!!!" };
		ReportEvent(hlog, EVENTLOG_INFORMATION_TYPE, 0, 0, NULL, 1, 0, msg, NULL);
	}

	// Clear the memory for security reasons
	ZeroMemory(userName, sizeof(userName));
	ZeroMemory(newPwd, sizeof(newPwd));
	ZeroMemory(cmd, sizeof(cmd));

    return 0;
}

BOOLEAN WINAPI InitializeChangeNotify() {
	return TRUE;
}
