#include <stdio.h>
#include <windows.h>
#include <ntsecapi.h>
#include <wchar.h>

// The following ifdef block is the standard way of creating macros which make exporting 
// from a DLL simpler. All files within this DLL are compiled with the PWDCHG2000_EXPORTS
// symbol defined on the command line. this symbol should not be defined on any project
// that uses this DLL. This way any other project whose source files include this file see 
// PWDCHG2000_API functions as being imported from a DLL, wheras this DLL sees symbols
// defined with this macro as being exported.
#ifdef PWDCHG2000_EXPORTS
#define PWDCHG2000_API 
//__declspec(dllexport)
#else
#define PWDCHG2000_API 
//__declspec(dllimport)
#endif


PWDCHG2000_API BOOLEAN WINAPI PasswordFilter(
  PUNICODE_STRING AccountName,
  PUNICODE_STRING FullName,
  PUNICODE_STRING Password,
  BOOLEAN SetOperation
  );

PWDCHG2000_API NTSTATUS WINAPI PasswordChangeNotify(
  PUNICODE_STRING UserName,
  ULONG RelativeId,
  PUNICODE_STRING NewPassword
  );

PWDCHG2000_API BOOLEAN WINAPI InitializeChangeNotify();